camera = 
{
	x = 0,
	y = 0,
	scaleX = 1,
	scaleY = 1,
	rot = 0,
}

local lg 		= love.graphics
local pop 		= lg.pop
local trans 	= lg.translate
local rotate 	= lg.rotate
local scale 	= lg.scale
local push 		= lg.push

function camera:set()
	push()
	trans(-self.x,-self.y)
	rotate(-self.rot)
	scale(1 / self.scaleX,1 / self.scaleY)
end

-- centers the camera so that the position is in the center of the screen
function camera:setPosition(x, y)
	self.x = x * (1/self.scaleX) - screen.width / 2
	self.y = y * (1/self.scaleY) - screen.height / 2
end

function camera:setScale(_sx, _sy)
	--sx = math.min(math.max(_sx or 1, 0.5), 3)
	--sy = math.min(math.max(_sy or 1, 0.5), 3)
	sx = tools.clamp(_sx or 1, 0.5, 2)
	sy = tools.clamp(_sy or 1, 0.5, 2)
	self.scaleX, self.scaleY = sx, sy
	print("camera: set scale: " .. sx .. " / " .. sy)
end

function camera:getScale()
	return self.scaleX, self.scaleY
end

function camera:unset()
	pop()
end

function camera:getPosition(_x, _y)
	local x, y
	_x = _x or self.x
	_y = _y or self.y
	x = (_x + screen.width / 2) * self.scaleX
	y = (_y + screen.height / 2) * self.scaleY
	return x, y
end

return camera