-- debug file

local Debug = {}

function Debug:load()
	self.entries = {}
	gameloop:addLoop(self)
end

function Debug:getNewId()
	local id = 1
	while self.entries[id] ~= nil do
		id = id + 1
	end
	return id
end

function Debug:addEntry(string)
	local obj = {id = Debug:getNewId(), text = string}
	table.insert(self.entries, obj)
end

function Debug:removeEntry(id)
	for i = #self.entries, 1, -1 do
		if self.entries[i] == string then
			table.remove(self.entries, i)
			return
		end
	end
end

function Debug:tick(dt)
	for i = 1, #self.entries do
		print(self.entries[i].text)
	end
end


return Debug