local GameLoop = {}

-- init game loop
function GameLoop:load()
	self.items = {}
end

-- add an object to the loop; from now on the object will call object.tick every update
function GameLoop:addLoop(obj)
	table.insert(self.items, obj)
	--[[
	if obj.id ~= nil then
		print("gl: add loop for obj id " .. obj.id)
	else
		print("gl: add loop for obj without id ")
	end
	--]]
end

-- remove an object from the loop
function GameLoop:removeLoop(obj)
	for i = #self.items, 1, -1 do
		if self.items[i] == obj then
			table.remove(self.items, i)
			return
		end
	end
end

-- update the game loop
function GameLoop:update(dt)
	for i = 1,#self.items do
		local obj = self.items[i]
		if obj ~= nil then
			obj:tick(dt)
		end
	end
end

return GameLoop