
-- at the moment it works the same as the object manager

local GUIMgr = {}

-- deprecated
--[[
local UI = {
	main_menu = {
		"btnStartMP",
		"btnJoinMP",
		"btnStartSP",
		"btnSettingsApp",
		"btnQuitApp",
	},
	
	lobby = {
		"btnLobbyStartGame",
		"btnLobbyToMainMenu",
	},
	
	ingame = {
	
	},
	
	ingame_settings = {
		"btnIngameSettingsToGame",
		"btnIngameSettingsToMainMenu",
	},
	
	settings = {
		"btnSettingsToMainMenu",
		"btnSettingsToggleFullscreen",
		"btnSettingsToggleBorderless",
		"lblSettingsFullscreen",
		"lblSettingsBorderless",
		"lblSettingsSoundAll",
		"regSettingsSoundsAll",
	},
}
--]]


function GUIMgr:load()
	self.objects = {}
	self.state = "main_menu"
	gameloop:addLoop(self)
end

function GUIMgr:tick(dt)

end

function GUIMgr:add(obj)

	if obj.load == nil then
		_id = obj.id
		if obj.id == nil then _id = "?" end
		print("guimgr note: object \"".._id.."\" has no load function!")
	else
		obj:load()
	end
	
	if obj.parent == nil then
		print("guimgr: cannot add object without parent!")
		return false
	end	
	
	if self.objects[obj.parent] == nil then
		--print("guimgr: new category: " .. obj.parent)
		self.objects[obj.parent] = {}
	end
	table.insert(self.objects[obj.parent], obj)
	
end

function GUIMgr:getElementByID(id)
	
	--print("guimgr: search id: " .. id)
	for k, container in pairs(self.objects) do
		for j = 1, #container do
			local _obj = self.objects[k][j]
			--print("guimgr: compare id " .. _obj.id)
			if _obj.id == id then
				--print("guimgr: id " .. id)
				return _obj
			end
		end
	end
	
	--[[
	for i = 1, #self.objects do
		local _obj = self.objects[i]
		if _obj.id == id then
			return _obj
		end
	end
	--]]
	return nil
end

function GUIMgr:getUIstate()
	return self.state
end

function GUIMgr:changeUIstate(_state)
	self.state = _state
	--print("guimgr: changed GUI state to: " .. _state)
	
	self:updateAllElements()
	
	if self.state == "ingame" then
		love.mouse.setVisible(false)
	else
		love.mouse.setVisible(true)
	end
end

-- control logic...
function GUIMgr:updateAllElements()

	for k, container in pairs(self.objects) do
		--print("guimgr: container " .. k)
		for j = 1, #container do
			if self.state == k then
				GUIMgr:setUIContainerVisibleFlag(container, true)
			else
				GUIMgr:setUIContainerVisibleFlag(container, false)
			end
		end
	end

end

-- note: state and visible are two different things...
function GUIMgr:setUIContainerVisibleFlag(container, visibleFlag)
	for k, obj in pairs(container) do
		--local obj = self:getElementByID(v)
		if obj ~= nil then
			if obj.state == 0 then
				obj.visible = false
			else
				obj.visible = visibleFlag
			end
		else
			print("guimgr object missing: " .. tostring(container))
		end
	end
end

function GUIMgr:hideButton(_id)	-- TODO: check if its a button
	local btn = guimgr:getElementByID(_id)
	btn.state = 0
	
	self:updateAllElements()
end

function GUIMgr:disableButton(_id)
	local btn = guimgr:getElementByID(_id)
	btn.state = 4
	
	self:updateAllElements()
end



return GUIMgr

