-- simple label to display text, no interaction

local Label = {}


function Label:create(_desc)

	local et = {id = _desc.id, x = _desc.x or 0, y = _desc.y or 0,
		width = _desc.width or 200, height = _desc.height or 50}
	local label = entity:create(et)
	
	function label:load()
		--gameloop:addLoop(self)
		renderer:addRenderer(self, LAYERGUI)
		
		--self.id = _desc.id
		self.parent = _desc.parent
		self.text = _desc.text or ":  :"
		self.color = _desc.color or {1, 1, 1, 1}
		self.textScale = _desc.textScale or 1
	end
	
	
	function label:tick(dt)
		-- not needed? gameloop not called
	end
	
	
	function label:setText(_text)
	
		self.text = _text
	end
	
	
	function label:draw()
	
		if not self.visible then
			return
		end
		
		
		r, g, b, a = love.graphics.getColor()
		love.graphics.setColor(self.color)
		love.graphics.print(self.text, self.x, self.y, 0, self.textScale, self.textScale)
		love.graphics.setColor(r, g, b, a)
		
	end
	
	return label

end


return Label
