entity = require "scripts/entity"

local MapObject = {}

function MapObject:create(_object)
	local mapObject = entity:create({x = _object.x, y = _object.y})
	
	mapObject.entityCategory	= "ec_mapobject"
	
	mapObject.size = 64
	mapObject.traversableGround	= false		-- says if players and mobs can move on this terrain
	mapObject.traversableAir	= false		-- says if players and mobs can fly over this terrain
	mapObject.blocking			= false		-- says if this terrain blocks projectiles and similar
	mapObject.canSpawnMobs		= false		-- (hostile) mobs and players can spawn on this terrain
	mapObject.canSpawnItems		= false		-- items can spawn on this terrain
	
	if _object.maskName ~= nil then
		--print("create mask: " .. _object.maskName)
		mapObject.mask				= imageloader.images[_object.maskName]	-- used for transitions
	end
	
	function mapObject:load()
		gameloop:addLoop(self)
		renderer:addRenderer(self, LAYERMAPOBJECTS)
		--self.id = _id
		--self.image = love.graphics.newImage("assets/graphics/block1.png")
		--self.size = 64
		
	end
	
	function mapObject:tick(dt)
		
	end
	
	--[[
	function mapObject:stencilFunction()
		love.graphics.setShader(mask_shader)
		love.graphics.draw(self.mask, self.x, self.y)
		love.graphics.setShader()
	end
	--]]
	
	function mapObject:draw()	-- draw function inside each individual object
		-- drawable, x, y, rotation, scale x/y, offset x/y, shearing factor x/y
		--love.graphics.draw(self.image, self.x, self.y, 0, 1, 1, 0, 0)
	end
	
	function mapObject:destroy()
		gameloop:removeLoop(self)
		renderer:removeRenderer(self)
		objmgr:destroyObject(self.id)
	end
	
	return mapObject
end


return MapObject