--entity = require "scripts/entity"
mapobject = require "scripts/mapobject"
imageloader = require "scripts/imageloader"

local Block = {}

function Block:create(_x, _y)
	local block = mapobject:create({x=_x, y=_y})
	block.entityType = "block"
	
	block.traversableGround = true
	block.traversableAir = true
	block.blocking = true
	block.canSpawnMobs = false
	block.canSpawnItems = false
	
	block.image = imageloader.images["block1"][1]	--imageloader:newImage("block1")

	function block:tick(dt)
		
	end
	
	function block:draw()
		-- drawable, x, y, rotation, scale x/y, offset x/y, shearing factor x/y
		love.graphics.draw(self.image, self.x, self.y, 0, 1, 1, 0, 0)
		
	end
	
	return block
end


return Block