mapobject = require "scripts/mapobject"

local Water = {}

function Water:create(_x, _y, _maskName, _subtype)
	--print("water mask: " .. _maskName)
	local water = mapobject:create({x =_x, y =_y, maskName = _maskName})
	water.entityType = "water"
	
	water.traversableGround = true
	water.traversableAir = true
	water.blocking = false
	water.canSpawnMobs = true
	water.canSpawnItems = true
	
	water.images = {}
	water.animationTick = 0
	water.currentImageIndex = 1
	
	if _subtype == 1 then
		water.animationWait = 0.5
		water.images = imageloader.images["water1"]
	--elseif _subtype == 2 then
		--water.animationWait = 1.5
		--water.images = imageloader.images["water2"]
	end
	
	--water.image = water.images[1]

	function water:tick(dt)
		self.animationTick = self.animationTick + dt
		
		if self.animationTick >= self.animationWait * math.random(15, 25) / 10 then
			self:nextAnimation()
			self.animationTick = 0
		end
	end
	
	
	function water:nextAnimation()
		self.currentImageIndex = self.currentImageIndex + 1
		if self.images[self.currentImageIndex] == nil then
			self.currentImageIndex = 1
		end
	end
	
	
	if _maskName ~= "mask1111" then	-- mask1111 means this mapobject is encompassed by the same mapobject type on every side!
		function water:stencilFunction()
			love.graphics.setShader(mask_shader)
			-- cannot use self here for some reason?
			love.graphics.draw(water.mask, water.x, water.y)
			love.graphics.setShader()
		end
	end
	
	
	function water:draw()
		
		if self.stencilFunction ~= nil then
			--print("water: set stencil")
			love.graphics.stencil(self.stencilFunction, "replace", 1)
			love.graphics.setStencilTest("greater", 0)
		end
		
		
		-- drawable, x, y, rotation, scale x/y, offset x/y, shearing factor x/y
		love.graphics.draw(self.images[self.currentImageIndex], self.x, self.y, 0, 1, 1, 0, 0)
		
		
		if self.stencilFunction ~= nil then
			love.graphics.setStencilTest()
		end
		
	end
	
	return water
end


return Water