-- store entity / object types in tables with shared properties
-- to be accessed quickly for collision checks etc

local Properties = {}

Properties.blockingMapObjectTypes = {
	1,	-- block
}

-- holds all the obstacles based on the movement type
Properties.obstacles = {}
Properties.obstacles["walk"] = {
	1,	-- block
	5, 	-- water
}
Properties.obstacles["fly"] = {
	1,	-- block
}
Properties.obstacles["swim"] = {	-- everything that is not water
	1,	-- block
	2,	-- grass
	3,	-- grass
	4,	-- stone
}


-- comfort functions ...

function Properties.getBlockingMapObjects()
	return Properties.blockingMapObjectTypes
end


function Properties.getObstaclesByMovementType(_movementType)
	return Properties.obstacles[_movementType]
end


return Properties
