-- regulator to modify a single value

local Regulator = {}


function Regulator:create(_desc)

	local et = {id = _desc.id, x = _desc.x or 0, y = _desc.y or 0,
		width = _desc.width or 200, height = _desc.height or 32}
	local regulator = entity:create(et)
	
	function regulator:load()
		gameloop:addLoop(self)
		renderer:addRenderer(self, LAYERGUI)
		
		--self.id = _desc.id
		self.parent = _desc.parent
		self.text = _desc.text or ":  :"
		self.color = _desc.color or {1, 1, 1, 1}
		self.textScale = _desc.textScale or 1
		self.min = 0
		self.max = _desc.max or 5
		self.sliderIndex = _desc.position or self.min
		self.sliderPosition = self.x	-- invalidated in tick
		self.image = imageloader.images["slider1"][1]
		--self.var = _desc.var
		self.steps = _desc.steps or 6
		self.incFunction = _desc.callbackInc
		self.decFunction = _desc.callbackDec
		self.imageScaleX = 32 / self.image:getWidth()
		self.imageScaleY = 32 / self.image:getHeight()
		self.color = _desc.color or {1.0, 1.0, 1.0, 0.1}
		
		guimgr:add(button:create({parent = _desc.parent, id = "btn"..self.id.."_L", x = self.x - self.width/2, y = self.y, text = "<<", width = 32, height = self.height,
			callback = function() self.sliderIndex = math.max(self.min, self.sliderIndex - 1); self.decFunction() end } ))
		
		guimgr:add(button:create({parent = _desc.parent, id = "btn"..self.id.."_R", x = self.x + self.width/2, y = self.y, text = ">>", width = 32, height = self.height,
			callback = function() self.sliderIndex = math.min(self.max, self.sliderIndex + 1); self.incFunction() end } ))
	end
	
	
	function regulator:tick(dt)
		self.sliderPosition = self.x - self.width/2 + self.sliderIndex * ((self.width - 64)/(self.max - self.min))
		--print("reg slider pos: " .. self.sliderPosition)
	end
	
	
	function regulator:draw()
	
		if not self.visible then
			return
		end
		
		
		--love.graphics.print(self.text, self.x, self.y, 0, self.textScale, self.textScale)
		r, g, b, a = love.graphics.getColor()
		love.graphics.setColor(self.color)
		love.graphics.rectangle("fill", self.x - self.width/2 + 32, self.y, self.width, self.height)
		love.graphics.setColor(r, g, b, a)
		love.graphics.draw(self.image, self.sliderPosition + 32, self.y, 0, self.imageScaleX, self.imageScaleY)
		
	end
	
	return regulator

end


return Regulator
