--app			= require "scripts/app"

-- the settings

local Settings = {}

function Settings:load()
	
	--self.visible = true
	gameloop:addLoop(self)
	renderer:addRenderer(self, LAYERGUI)
	
	guimgr:add(button:create({parent = "settings", id = "btnSettingsToggleFullscreen", x = 280, y = 200, text = "Toggle Fullscreen", callback = function() app:toggleFullscreen() end } ))
	guimgr:add(button:create({parent = "settings", id = "btnSettingsToggleBorderless", x = 280, y = 240, text = "Toggle Borderless", callback = function() app:toggleBorderless() end } ))
	
	guimgr:add(button:create({parent = "settings", id = "btnSettingsToMainMenu", x = 128, y = 400, text = "Back to Main Menu", callback = function() app:backToMainMenu() end } ))
	
	guimgr:add(entry:create({parent = "settings", id = "entrySettingsPlayername", x = 128, y = 88, text = "Player name:", maxLength = 12} ))
	guimgr:add(button:create({parent = "settings", id = "btnSettingsConfirmPlayername", x = 280, y = 88, text = "Set playername", callback = function() app:setPlayername() end } ))
	
	guimgr:add(entry:create({parent = "settings", id = "entrySettingsServerAddress", x = 128, y = 132, text = "Server address:", maxLength = 15} ))
	guimgr:add(button:create({parent = "settings", id = "btnSettingsConfirmServerAddress", x = 280, y = 132, text = "Set server address", callback = function() app:setServerAddress() end } ))
	
	guimgr:add(label:create({parent = "settings", id = "lblSettingsFullscreen", text = "Fullscreen:", x = 128, y = 208}))
	guimgr:add(label:create({parent = "settings", id = "lblSettingsBorderless", text = "Borderless:", x = 128, y = 248}))
	guimgr:add(label:create({parent = "settings", id = "lblSettingsSoundGame", text = "Game Sounds:", x = 128, y = 288}))
	guimgr:add(label:create({parent = "settings", id = "lblSettingsSoundMusic", text = "Music:", x = 128, y = 328}))
	
	--guimgr:add(label:create({parent = "settings", id = "lblSettingsDisplayName", text = "Your name:", x = 128, y = 88}))
	--guimgr:add(label:create({parent = "settings", id = "lblSettingsDisplayNameInfo", text = "(type to change)", x = 128, y = 108}))
	
	local regSoundGame = {
		parent = "settings",
		id = "regSettingsSoundsGame",
		x = 340,
		y = 280,
		--increment = 0.1,
		min = 0,
		max = 10,
		position = app.settings.soundValues["game"] * 10,
		-- increase / decrease function
		callbackInc = function() app:soundIncrease("game", 0.1) end,
		callbackDec = function() app:soundDecrease("game", 0.1) end,
	}
	guimgr:add(regulator:create(regSoundGame))
	
	local regSoundMusic = {
		parent = "settings",
		id = "regSettingsSoundsMusic",
		x = 340,
		y = 320,
		--increment = 0.1,
		min = 0,
		max = 10,
		position = app.settings.soundValues["music"] * 10,
		-- increase / decrease function
		callbackInc = function() app:soundIncrease("music", 0.1) end,
		callbackDec = function() app:soundDecrease("music", 0.1) end,
	}
	guimgr:add(regulator:create(regSoundMusic))
	
	--print(app.gamestate)
	
end


function Settings:tick(dt)
	if guimgr:getUIstate() ~= "settings" then
		return
	end
	
	local human = app:getHumanPlayer()
	local label = guimgr:getElementByID("lblSettingsDisplayName")
	if label ~= nil and human ~= nil then
		label:setText("Your name: " .. human.displayname)
	end
end


function Settings:draw()
	if guimgr:getUIstate() ~= "settings" then
		return
	end
	
	--[[
	local y = 0
	for k, v in pairs(app.settings) do
		love.graphics.print(tostring(k) .. ": " .. tostring(v), 300, 208 + 40 * y, 0, 1, 1)
		y = y + 1
	end
	--]]
	
end


return Settings

