local Soundmgr = {}

Soundmgr.sounds = {}
Soundmgr.currentSounds = {}

-- stream = play from hard drive / static = load into memory


-- music
Soundmgr.sounds["music"] = {
	music1 = love.audio.newSource("assets/sounds/Atmospheric-10.wav", "stream"),
}

-- sounds
Soundmgr.sounds["game"] = {
	roar1 = love.audio.newSource("assets/sounds/roar_1.wav", "static"),

	bang1 = love.audio.newSource("assets/sounds/bang2.wav", "static"),
	bang2 = love.audio.newSource("assets/sounds/bang2.wav", "static"),

	zombie1_misc1 = love.audio.newSource("assets/sounds/Tech-05.wav", "static"),
	zombie1_misc2 = love.audio.newSource("assets/sounds/Movements-12.wav", "static"),
}

do
	
	love.audio.setEffect('reverbEffect', {type = 'reverb'})
	
--	Soundmgr.sounds["bang1"]:setEffect("reverbEffect")
end


-- TODO: ignore call if sound is deactivated in the app
Soundmgr.playSound = function(_source, _looping)
	
	--Soundmgr.addSound(_source)
	--_source:play()
	--_source:setLooping(_looping or false)
	
--
	if _source:isPlaying() then
		--print("already playing")
		-- clone?
		if not _looping then	-- do not clone a looping sound!
			Soundmgr.playSound(_source:clone(), _looping or false)
		end
	else
		--print("new sound")
		Soundmgr.addSound(_source)
		_source:play()
		_source:setLooping(_looping or false)
	end
--
end


Soundmgr.addSound = function(_source)
	table.insert(Soundmgr.currentSounds, _source)
	--print("adding new sound")
end


Soundmgr.stopSound = function(_source)
	if _source:isPlaying() then
		print("soundmgr: stopping sound")
		love.audio.stop(_source)
	end
end


Soundmgr.update = function(dt)
	for i = #Soundmgr.currentSounds, 1, -1 do
		local source = Soundmgr.currentSounds[i]
		if not source:isPlaying() then
			table.remove(Soundmgr.currentSounds, i)
			--print("remove sound")
		end
	end
end


Soundmgr.updateVolume = function(_category)

	--print("soundmgr: update volume, category: " .. _category)
	
	-- TODO: rework... make it like this: volume = masterVolume * categoryVolume
	if _category == "music" or _category == "game" then
		for k, v in pairs(Soundmgr.sounds[_category]) do
			v:setVolume(app.settings.soundValues[_category])
			--print("soundmgr: set volume for " .. k .. " to " .. app.settings.soundValues[_category])
		end
	else
		print("soundmgr: unknown sound category " .. _category)
	end
	
end


return Soundmgr
