-- default (background terrain)

imageloader = require "scripts/imageloader"

local Terrain = {}

function Terrain:create(_x, _y)

	local terrain = {x = _x, y = _y, image = imageloader.images["stone1"][1]}
	terrain.entityType = "terrain"
	
	function terrain:load()
		renderer:addRenderer(self, LAYERTERRAIN)
	end
	
	function terrain:draw()
		love.graphics.draw(self.image, self.x, self.y, 0, 1, 1, 0, 0)
	end
	
	function terrain:destroy()
		renderer:removeRenderer(self)
		objmgr:destroyObject(self)
	end
	
	return terrain
	
end



return Terrain
