-- manage the user input (keyboard, mouse?)

local Userinput = {}
local updateRate = 0.01
local updateTick = 0
-- TODO: for now (test) only "listen" to user input 10x per second (because network...)

local APPTYPE_SOLO = 0
local APPTYPE_SERVER = 1
local APPTYPE_CLIENT = 2

-- all keys that are allowed to be used for the local players displayname, ä ö ü do not work (yet)
local nameKeys = { "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "ä", "ö", "ü", "ß",
"A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "Ä", "Ö", "Ü" }

local ipAdressKeys = { ".", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0" }

function Userinput:load()
	self.focus = nil
	gameloop:addLoop(self)
end


function Userinput:tick(dt)
	
	--if self.focus ~= nil then
		--print("Userinput: set focus to " .. self.focus)
	--end
	
	updateTick = updateTick + dt
	
	if updateTick > updateRate then
		
		local uistate = guimgr:getUIstate()
		local human = app:getHumanPlayer()
		local appType = app:getType()
		
		if uistate == "ingame" then
			local entityID = game:getPlayerEntityByHumanID(human.id)
			--print("Userinput: human is " .. human.id)
			if entityID then
				--print("Userinput: player entity ID is " .. entityID)
				local playerEntity = objmgr:getObjectByID(entityID)
				if playerEntity then
					
					if appType == APPTYPE_CLIENT then
						network.client.sendPlayerEntityMovementUpdate(playerEntity)
					
					elseif appType == APPTYPE_SERVER then
						network.server.sendPlayerEntityMovementUpdate(playerEntity)
					end
					
					if love.keyboard.isDown("a") then
						if appType == APPTYPE_CLIENT then
							-- kindly ask the server if this movement is ok
							--network.client.sendPlayerKeypress("a")
							
						elseif appType == APPTYPE_SERVER then
							-- server: inform all clients about his player movement
							--network.server.sendEntityMovementUpdate()
						end
						-- perform movement on local machine (if client: server is going to respond...)
						playerEntity:accelerate(dt, - playerEntity.maxAcceleration, 0)
						
					elseif love.keyboard.isDown("d") then
						if appType == APPTYPE_CLIENT then
							--network.client.sendPlayerKeypress("d")
						end
						playerEntity:accelerate(dt, playerEntity.maxAcceleration, 0)
						
					end
					
					if love.keyboard.isDown("w") then
						if appType == APPTYPE_CLIENT then
							--network.client.sendPlayerKeypress("w")
						end
						playerEntity:accelerate(dt, 0, - playerEntity.maxAcceleration)
						
					elseif love.keyboard.isDown("s") then
						if appType == APPTYPE_CLIENT then
							--network.client.sendPlayerKeypress("s")
						end
						playerEntity:accelerate(dt, 0, playerEntity.maxAcceleration)
						
					end
				end
			end
			
		end
		
		updateTick = 0
		
	end	-- updateRate
end


function Userinput:setFocus(_uiElementID)
	if guimgr:getElementByID(_uiElementID) == nil then return false end
	
	--print("Userinput: set focus to " .. _uiElementID)
	self.focus = _uiElementID
end

function Userinput:getFocus()
	return self.focus
end

function Userinput:resetFocus()
	self.focus = nil
end


function love.keypressed(key)
	local uistate = guimgr:getUIstate()
	local human = app:getHumanPlayer()
	local appType = app:getType()
	
	if uistate == "ingame" then
	
		if key == "escape" then
			guimgr:changeUIstate("ingame_settings")
			
		-- zoom in/out
		elseif key == "+" then
			if uistate == "ingame" then
				local sx, sy = cam:getScale()
				cam:setScale(sx - 0.1, sy - 0.1)
			end
		elseif key == "-" then
			if uistate == "ingame" then
				local sx, sy = cam:getScale()
				cam:setScale(sx + 0.1, sy + 0.1)
			end
		
		elseif key == "p" then
			--[[
			-- debug: get info about controlled player entity
			local entityID = game:getPlayerEntityByHumanID(human.id)
			print("Main: human is " .. human.id)
			if entityID then
				print("Main: player entity ID is " .. entityID)
				local playerEntity = objmgr:getObjectByID(entityID)
				if playerEntity then
					playerEntity:accelerate(0.001, 20, 0)	-- test only
				end
			end
			--]]
			if appType == APPTYPE_CLIENT then
				network.client.pingServer()
			end
			
		end
		
	elseif uistate == "ingame_settings" then
	
		if key == "escape" then
			guimgr:changeUIstate("ingame")
		end
		
	elseif uistate == "settings" then
	
		if key == "escape" then
			guimgr:changeUIstate("main_menu")
		
		else

			-- TODO: entry widgets ...
			local focusID = userinput:getFocus()
			if focusID then
				--print("Userinput: focus is on " .. focusID)
				local uiElement = guimgr:getElementByID(focusID)
				local text = uiElement:getText() or "?"
				--print("Userinput: ui text is " .. text)
				
				if key == "backspace" then
					-- see: https://love2d.org/wiki/love.textinput
					-- get the byte offset to the last UTF-8 character in the string.
					--local human = app:getHumanPlayer()
					local byteoffset = utf8.offset(text, -1)
					if byteoffset then
						-- remove the last UTF-8 character.
						-- string.sub operates on bytes rather than UTF-8 characters, so we couldn't do string.sub(TEXT, 1, -2).
						--TEXT = string.sub(TEXT, 1, byteoffset - 1)
						local newText = string.sub(text, 1, byteoffset - 1)
						uiElement:setText(newText)
					else
						soundmgr.playSound(soundmgr.sounds["game"]["bang1"])
					end
				end
			end
			--[[
			if key == "backspace" then
				-- see: https://love2d.org/wiki/love.textinput
				-- get the byte offset to the last UTF-8 character in the string.
				--local human = app:getHumanPlayer()
				local byteoffset = utf8.offset(human.displayname, -1)
				if byteoffset then
					-- remove the last UTF-8 character.
					-- string.sub operates on bytes rather than UTF-8 characters, so we couldn't do string.sub(TEXT, 1, -2).
					--TEXT = string.sub(TEXT, 1, byteoffset - 1)
					newText = string.sub(human.displayname, 1, byteoffset - 1)
					app:updatePlayer({displayname = newText})
				else
					soundmgr.playSound(soundmgr.sounds["game"]["bang1"])
				end
			end
			--]]
		end
		
	elseif uistate == "lobby" then
	
		if key == "d" then
			lobby:printPlayers()
		end
		
	else	--(main_menu)
	
		if key == "escape" then
			love.event.quit()
		end
		
	end
	
	--[[
	elseif key == "g" then
		guimgr:changeUIstate("ingame")
	elseif key == "l" then
		guimgr:changeUIstate("lobby")
	elseif key == "m" then
		guimgr:changeUIstate("main_menu")
	elseif key == 'b' then
		guimgr:disableButton("btnJoinMP")
		guimgr:hideButton("btnStartSP")
	elseif key == 'r' then
		love.load()
	--]]
	
	--[[	
	elseif key == 'space' then
		soundmgr.playSound(soundmgr.sounds["bang1"], false)
	elseif key == 'n' then
		soundmgr.stopSound(soundmgr.sounds["bang1"])
	--]]
	
end


function love.textinput(t)
	local uistate = guimgr:getUIstate()
	
	-- TODO: see above
	if uistate == "settings" then
		local focusID = userinput:getFocus()
		if focusID then
			local uiElement = guimgr:getElementByID(focusID)
			local text = uiElement:getText() or "?"
			local maxLength = uiElement:getMaxLength()
			local tableToCheck
			
			if focusID == "entrySettingsPlayername" then
				tableToCheck = nameKeys
			elseif focusID == "entrySettingsServerAddress" then
				tableToCheck = ipAdressKeys
			end
			
			if tools.isValueInTable(t, tableToCheck) then
				if string.len(text) > maxLength - 1 then
					return
				end
				newText = text .. t
				--app:updatePlayer( {displayname = newText} )
				uiElement:setText(newText)
			else
				soundmgr.playSound(soundmgr.sounds["game"]["bang1"])
			end
		end
		
		--[[
		if tools.isValueInTable(t, nameKeys) then
			local human = app:getHumanPlayer()
			if string.len(human.displayname) > 9 then	-- allows 10 chars
				return
			end
			newText = human.displayname .. t
			app:updatePlayer( {displayname = newText} )
		else
			soundmgr.playSound(soundmgr.sounds["game"]["bang1"])
		end
		--]]
	end
end


return Userinput
